#-*- coding:utf-8 -*-

import clr
import sys

clr.AddReferenceByPartialName("PresentationCore")
clr.AddReferenceByPartialName("PresentationFramework")
clr.AddReferenceByPartialName("WindowsBase")
clr.AddReference("System.Management")

from System import *
from System.IO import *
from System.Windows import *
from System.Windows.Controls import *
from System.Windows.Controls.Primitives import *
from System.Windows.Input import *
from System.Collections.ObjectModel import *
from System.Windows.Markup import XamlReader
from System.Windows.Media.Imaging import *
from System.Windows.Media.Effects import *
import System.Management
import inifile8
from xamls import *
from datas import *
from strs import *
import aboutdlg

class Editor():
    pass

class NotePage(DockPanel):
    pass

class SeeMe(Window):
    """
        SeeMe MainWindow class
    """
    def __init__(self, sset):
        """
            Window.__init__(self) is No
            Constructor has been
        """
        # Memory FilePath
        self.path = Path.GetDirectoryName(Path.GetFullPath(__file__))
        self.sset = sset
        self.iniver = 0
        # this setting
        self.Top = sset.top
        self.Left = sset.left
        self.Width = sset.width
        self.Height = sset.height
        # Menu
        menu = XamlReader.Parse(menu_str)
        menu.FindName("save").Click += self.on_save
        menu.FindName("quit").Click += self.on_quit
        menu.FindName("item_delete").Click += self.on_item_delete
        menu.FindName("about").Click += self.on_about
        DockPanel.SetDock(menu, Dock.Top)
        # ToolBar
        toolbar = XamlReader.Parse(toolbar_str)
        toolbar.FindName("btn2").Click += self.on_save
        toolbar.FindName("btn5").Click += self.on_item_delete
        toolbar.FindName("img1").Source = BitmapImage(Uri(self.path + "\\img\\i_new.png"))
        toolbar.FindName("img2").Source = BitmapImage(Uri(self.path + "\\img\\i_save.png"))
        toolbar.FindName("img3").Source = BitmapImage(Uri(self.path + "\\img\\i_up.png"))
        toolbar.FindName("img4").Source = BitmapImage(Uri(self.path + "\\img\\i_down.png"))
        toolbar.FindName("img5").Source = BitmapImage(Uri(self.path + "\\img\\i_del.png"))
        DockPanel.SetDock(toolbar, Dock.Top)
        # ObservableCollection
        self.custome_liststore = ObservableCollection[Engine]()
        self.default_liststore = ObservableCollection[Engine]()
        # ListView
        self.custome_listview = XamlReader.Parse(listview_str)
        self.custome_listview.SelectionChanged += self.on_custome_selection_change
        #DockPanel.SetDock(self.custome_listview, Dock.Top)
        self.custome_listview.ItemsSource = self.custome_liststore
        self.default_listview = XamlReader.Parse(listview_str)
        self.default_listview.SelectionChanged += self.on_default_selection_change
        #DockPanel.SetDock(self.default_listview, Dock.Top)
        self.default_listview.ItemsSource = self.default_liststore
        # Editor
        self.editor = Editor()
        edit = XamlReader.Parse(editor_str)
        self.editor.edit_name       = edit.FindName("edit_name")
        self.editor.edit_key        = edit.FindName("edit_key")
        self.editor.edit_url        = edit.FindName("edit_url")
        self.editor.edit_query      = edit.FindName("edit_query")
        self.editor.edit_uniqueid   = edit.FindName("edit_uniqueid")
        self.editor.check_post      = edit.FindName("check_post")
        self.editor.edit_icon       = edit.FindName("edit_icon")
        self.editor.check_separator = edit.FindName("check_separator")
        self.editor.edit_encode     = edit.FindName("edit_encode")
        self.editor.edit_type       = edit.FindName("edit_type")
        self.editor.label_etc       = edit.FindName("label_etc")
        edit.FindName("button").Click += self.on_edit_accept
        DockPanel.SetDock(edit, Dock.Bottom)
        # Default UNIQUEID View
        duview = DockPanel()
        dulabel = Label()
        dulabel.Content = "UNIQUEID"
        self.def_uid_entry = TextBox()
        self.def_uid_entry.IsReadOnly = True
        duview.Children.Add(dulabel)
        duview.Children.Add(self.def_uid_entry)
        DockPanel.SetDock(duview, Dock.Bottom)
        # DEditor
        deditor = XamlReader.Parse(deditor_str)
        self.deditor = Editor()
        self.deditor.edit_uid1 = deditor.FindName("edit_uid1")
        self.deditor.edit_uid2 = deditor.FindName("edit_uid2")
        self.deditor.radio = []
        for i in range(3):
            self.deditor.radio.append(deditor.FindName("r%d" % i))
        self.deditor.radio[sset.verbtext].IsChecked = True
        self.deditor.edit_editor = deditor.FindName("edit_editor")
        # Note Page
        notepage = []
        for i in range(3):
            np = NotePage()
            if i == 0:
                np.Children.Add(edit)
                np.Children.Add(self.custome_listview)
            elif i == 1:
                np.Children.Add(duview)
                np.Children.Add(self.default_listview)
            else:
                np.Children.Add(deditor)
            notepage.append(np)
        # Notebook
        self.page = []
        note = TabControl()
        for i in range(3):
            page = TabItem()
            page.Header = tab_label[i]
            note.AddChild(page)
            self.page.append(page)
            self.page[i].Content = notepage[i]
        # StatusBar
        statusbar = StatusBar()
        DockPanel.SetDock(statusbar, Dock.Bottom)
        self.statusbar_item = StatusBarItem()
        self.statusbar_item.Content = "Search.ini Version"
        statusbar.Items.Add(self.statusbar_item)
        # DockPanel
        docpanel = DockPanel()
        docpanel.Children.Add(menu)
        docpanel.Children.Add(toolbar)
        docpanel.Children.Add(statusbar)
        docpanel.Children.Add(note)
        # self
        self.Content = docpanel
        self.Icon = BitmapFrame.Create(Uri(Path.Combine(self.path, "img\\seeme.ico")))
        self.Title = "SeeMe for Windows"
        # event
        self.KeyDown += self.on_keydown
        self.Closing += self.on_closing
        self.Closed += self.on_closed
        # read
        self.read_default_searchini()
        self.read_custome_searchini()

    def on_closing(self, sender, e):
        pass

    def on_closed(self, sender, e):
        path = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\sasakima"
        if not Directory.Exists(path):
            Directory.CreateDirectory(path)
        path += "\\seeme"
        if not Directory.Exists(path):
            Directory.CreateDirectory(path)
        path += "\\setting4.ini"
        ini = inifile8.Inifile(path);
        try:
            ini.write_int("Version", "File Version", 4)
            ini.write_int("Window", "Width", int(self.Width))
            ini.write_int("Window", "Height", int(self.Height))
            ini.write_int("Window", "Top", int(self.Top))
            ini.write_int("Window", "Left", int(self.Left))
            ini.write_str("Path", "Default1", self.sset.default_path)
            ini.write_str("Path", "Custome1", self.sset.custome_path)
            ini.write_str("Path", "Lang1", self.sset.lang_path)
            ini.write_str("Setting", "Editor", self.deditor.edit_editor.Text)
            ini.write_int("Setting", "Verbtextt", self.get_radio_num())
            ini.header = ";SeeMe Preferences version 1.0\r\n\r\n"
            ini.save()
        except Exception, s:
            self.messagebox(s)


########################################################################
#
#                          Functions
#
########################################################################


    def messagebox(self, text):
        return MessageBox.Show(text, MESSAGEDLG_TITLE)

    def read_default_searchini(self):
        #self.default_liststore.Clear()
        ini_path = self.sset.default_path
        lng_path = self.sset.lang_path
        if (File.Exists(ini_path)):
            ini = inifile8.Inifile(ini_path)
            lng = inifile8.InifileReader(lng_path)
            try:
                self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.nameid = ini.read_int(s, "Nameid", 0);
                    if en.nameid != 0:
                        # lng から表示名を取ってくる
                        # Google の計算方法が不明だけどコレで問題無いからイイや！
                        if en.nameid == 17171:
                            en.name = lng.read_str("Translation", "1632215285", "")
                        elif en.nameid == 17183:
                            en.name = lng.read_str("Translation", "-1971470391", "")
                        elif en.nameid == 71103:
                            en.name = lng.read_str("Translation", "-1453429782", "")
                        else:
                            en.name = lng.read_str("Translation", str(en.nameid), "")
                        if en.name == "":
                            n = -1752227277 - en.nameid;
                            en.name = lng.read_str("Translation", str(n), "")
                    else:
                        en.name = ini.read_str(s, "Name", "")
                        #en.name = unicode(ini.read_str(s, "Name", ""), "utf8")
                        #print en.name
                    en.key    = t
                    en.url    = ini.read_str(s, "URL", "")
                    en.query  = ini.read_str(s, "Query", "")
                    en.post   = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.type   = ini.read_int(s, "Search Type", 0)
                    en.pos    = ini.read_int(s, "Position", -1)
                    en.verb   = ini.read_int(s, "Verbtext", 0)
                    en.delete = True #！
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.icon   = ini.read_str(s, "ICON", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    self.default_liststore.Add(en)
                    #self.default_listview.Items.Add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_custome_searchini(self):
        self.custome_liststore.Clear()
        ini_path = self.sset.custome_path
        if (File.Exists(ini_path)):
            ini = inifile8.Inifile(ini_path)
            try:
                if self.iniver == 0:
                    self.iniver = ini.read_int("Version", "File Version", 0)
                self.statusbar_item.Content = "Search.ini Version " + str(self.iniver)
                # v10.60
                # TODO
                d1 = ini.read_str("Options", "Default Search", "")
                d2 = ini.read_str("Options", "Speed Dial Search", "")
                self.deditor.edit_uid1.Text = d1
                self.deditor.edit_uid2.Text = d2
                s = ""
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    en = Engine()
                    en.name   = ini.read_str(s, "Name", "")
                    en.key    = ini.read_str(s, "Key", "")
                    en.url    = ini.read_str(s, "URL", "")
                    en.delete = not ini.read_bool(s, "Deleted", False)
                    en.query  = ini.read_str(s, "Query", "")
                    en.post   = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.type   = ini.read_int(s, "Search Type", 0)
                    en.pos    = ini.read_int(s, "Position", -1)
                    en.nameid = ini.read_int(s, "Nameid", 0)
                    en.verb   = ini.read_int(s, "Verbtext", 0)
                    en.icon   = ini.read_str(s, "ICON", "")
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    # Default Delete as No append
                    default_delete = False
                    if not en.delete:
                        for row in self.default_liststore:
                            if row.unique == en.unique:
                                row.delete = False
                                default_delete = True
                                break
                    if not default_delete:
                        self.custome_liststore.Add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_operaprefs_ini(self):
        pass

    def create_uuid(self):
        uuids = []
        for row in self.default_liststore:
            uuids.append(row.unique)
        for row in self.custome_liststore:
            uuids.append(row.unique)
        while 1:
            result = Guid.NewGuid().ToString("N").ToUpper()
            if result in uuids:
                continue
            return result

    def get_radio_num(self):
        if self.deditor.radio[1].IsChecked:
            return 1
        elif self.deditor.radio[2].IsChecked:
            return 2
        else:
            return 0


########################################################################
#
#                          ListView
#
########################################################################

    def on_default_selection_change(self, sender, e):
        n = sender.SelectedIndex
        if n == -1:
            return
        self.def_uid_entry.Text = self.default_liststore[n].unique

    def on_custome_selection_change(self, sender, e):
        n = sender.SelectedIndex
        if n == -1:
            return
        self.editor.edit_name.Text            = self.custome_liststore[n].name
        self.editor.edit_key.Text             = self.custome_liststore[n].key
        self.editor.edit_url.Text             = self.custome_liststore[n].url
        self.editor.edit_query.Text           = self.custome_liststore[n].query
        self.editor.edit_uniqueid.Text        = self.custome_liststore[n].unique
        self.editor.check_post.IsChecked      = self.custome_liststore[n].post
        self.editor.edit_icon.Text            = self.custome_liststore[n].icon
        self.editor.check_separator.IsChecked = self.custome_liststore[n].endsep
        self.editor.edit_encode.Text          = self.custome_liststore[n].encode
        self.editor.edit_type.Text            = self.custome_liststore[n].type.ToString()
        self.editor.label_etc.Content         = ETC_TEXT % (
                self.custome_liststore[n].verb,
                self.custome_liststore[n].pos,
                self.custome_liststore[n].nameid,
                self.custome_liststore[n].usetld
            )

    def on_edit_accept(self, sender, e):
        n = self.custome_listview.SelectedIndex
        if n < 0:
            MessageBox.Show("編集するアイテムを選択又は新規作成してください", "SeeMe")
            return
        """if self.find_of_key():
            MessageBox.Show("競合するキーが見つかりました\nどちらかを変更又は非表示にしてください", "SeeMe", MessageBoxButton.OK, MessageBoxImage.Error)
            return
        """
        g = self.custome_liststore[n]
        g.name    = self.editor.edit_name.Text
        g.key     = self.editor.edit_key.Text
        g.url     = self.editor.edit_url.Text
        g.query   = self.editor.edit_query.Text
        g.unique  = self.editor.edit_uniqueid.Text
        g.post    = self.editor.check_post.IsChecked
        g.icon    = self.editor.edit_icon.Text
        g.endsp   = self.editor.check_separator.IsChecked
        g.encode  = self.editor.edit_encode.Text
        g.type    = int.Parse(self.editor.edit_type.Text)


########################################################################
#
#                          Menu and Toolbar
#
########################################################################


    def on_save(self, sender, e):
        """
            none
        """
        ps_arr = Diagnostics.Process.GetProcessesByName("opera")
        for ps in ps_arr:
            if "opera" == ps.ProcessName:
                ml = MessageBox.Show("Opera が起動しています、強制保存しますか？",  "SeeMe", MessageBoxButton.YesNo, MessageBoxImage.Warning)
                if ml == MessageBoxResult.No:
                    return
        ini = inifile8.Inifile(self.sset.custome_path)
        try:
            ini.write_int("Version", "File Version", self.iniver)
            # v10.60
            ps = self.deditor.edit_uid1.Text
            if ps == "":
                ini.erase_key("Options", "Default Search")
            else:
                ini.write_str("Options", "Default Search", ps)
            ps = self.deditor.edit_uid2.Text
            if ps == "":
                ini.erase_key("Options", "Speed Dial Search")
            else:
                ini.write_str("Options", "Speed Dial Search", ps)
            # end
            i = 0
            for row in self.default_liststore:
                # Deleted のみ書き込み
                if row.delete == False:
                    i += 1
                    # 順番は内臓エディタと同じにしたつもり
                    s = "Search Engine %i" % i
                    ini.write_str(s, "UNIQUEID", row.unique)
                    if row.nameid == 0:
                        ini.write_str(s, "Name", row.name)
                    else:
                        ini.write_str(s, "Name", "")
                    ini.write_int(s, "Verbtext", row.verb)
                    ini.write_str(s, "URL", row.url)
                    ini.write_str(s, "Query", row.query)
                    ini.write_str(s, "Key", row.key)
                    ini.write_bool(s, "Is post", row.post)
                    if row.usetld == 0:
                        ini.erase_key(s, "UseTLD")
                    else:
                        ini.write_int(s, "UseTLD", row.usetld)
                    if row.endsep:
                        ini.write_int(s, "Has endseparator", -1)
                    else:
                        ini.write_int(s, "Has endseparator", 0)
                    ini.write_str(s, "Encoding", row.encode)
                    ini.write_int(s, "Search Type", row.type)
                    ini.write_int(s, "Position", row.pos)
                    ini.write_int(s, "Nameid", row.nameid)
                    """if row.icon == "":
                        ini.erase_key(s, "ICON")
                    else:
                        ini.write_str(s, "ICON", row.icon)"""
                    ini.write_int(s, "Deleted", 1)
            for row in self.custome_liststore:
                # custome の書き込み
                i += 1
                s = "Search Engine %i" % i
                ini.write_str(s, "UNIQUEID", row.unique)
                ini.write_str(s, "Name", row.name)
                #ini.write_int(s, "Verbtext", row[11])
                num = self.get_radio_num()
                if num == 2:
                    ini.write_int(s, "Verbtext", -1988219522)# = -1988219522
                else:
                    ini.write_int(s, "Verbtext", 0)
                ini.write_str(s, "URL", row.url)
                ini.write_str(s, "Query", row.query)
                ini.write_str(s, "Key", row.key)
                ini.write_bool(s, "Is post", row.post)
                #ini.write_int(s, "UseTLD", row[14])
                if row.usetld == 0:
                    ini.erase_key(s, "UseTLD")
                else:
                    ini.write_int(s, "UseTLD", row.usetld)
                if row.endsep:
                    ini.write_int(s, "Has endseparator", -1)
                else:
                    ini.write_int(s, "Has endseparator", 0)
                ini.write_str(s, "Encoding", row.encode)
                ini.write_int(s, "Search Type", row.type)
                ini.write_int(s, "Position", row.pos)
                ini.write_int(s, "Nameid", row.nameid)
                if row.icon == "":
                    ini.erase_key(s, "ICON")
                else:
                    ini.write_str(s, "ICON", row.icon)
                if row.delete:
                    ini.write_int(s, "Deleted", 0)
                else:
                    ini.write_int(s, "Deleted", 1)
            while 1:
                # 消した section の削除
                i += 1
                s = "Search Engine %i" % i
                if not ini.section_exists(s):
                    break
                ini.erase_section(s)
            ini.header = HEADER_STR
            ini.save()
        except Exception, s:
            self.messagebox("%s" % s)
            sys.exit()
        #self.appry()

    def on_quit(self, sender, e):
        """
            exit
        """
        self.Close()

    def on_item_delete(self, sender, e):
        n = self.custome_listview.SelectedIndex
        if n == -1:
            self.messagebox("削除するアイテムを選択してください")
            return
        self.custome_liststore.RemoveAt(n)
        if self.custome_listview.Items.Count != 0:
            if n == self.custome_listview.Items.Count:
                self.custome_listview.SelectedIndex = n - 1
            else:
                self.custome_listview.SelectedIndex = n

    def on_about(self, sender, e):
        dlg = aboutdlg.AboutDlg(self)
        dlg.Show()

    def on_keydown(self, sender, e):
        """
            e as System.Windows.Input.KeyEventArgs
        """
        if Keyboard.Modifiers == ModifierKeys.Control:
            if e.Key == Key.O:
                self.on_save(self, e)
            if e.Key == Key.Q:
                self.on_quit(self, e)


########################################################################
#
#                               Welcome
#
########################################################################


class WelcomeDlg(Window):
    """
        SeeMe Welcome class
    """
    def __init__(self, sset, text):
        names = ["Default search.ini", "Custome search.ini", "lng File"]
        self.entrys = []
        sp = StackPanel()
        # description
        description = TextBlock()
        description.Text = text
        sp.Children.Add(description)
        # Edit
        for i in range(3):
            dp = DockPanel()
            tb = TextBlock()
            tb.Text = names[i]
            tb.MinWidth = 130
            tx = TextBox()
            tx.AllowDrop = True
            tx.Drop += self.on_drop
            tx.PreviewDragOver += self.on_drag_over
            self.entrys.append(tx)
            dp.Children.Add(tb)
            dp.Children.Add(tx)
            sp.Children.Add(dp)
        buttons = DockPanel()
        buttons.LastChildFill = False
        ok = Button()
        ok.Content = "_Ok"
        ok.IsDefault = True
        ok.Width = 100
        ok.Height = 23
        ok.Click += self.on_ok
        DockPanel.SetDock(ok, Dock.Right)
        buttons.Children.Add(ok)
        cancel = Button()
        cancel.Content = "Cancel"
        cancel.IsCancel = True
        cancel.Width = 100
        cancel.Height = 23
        cancel.Click += self.on_cancel
        DockPanel.SetDock(cancel, Dock.Right)
        buttons.Children.Add(cancel)
        sp.Children.Add(buttons)
        self.Content = sp
        # path x86 or x64
        prfiles = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles)
        appdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)
        mc = System.Management.ManagementClass("Win32_Processor")
        moc = mc.GetInstances()
        # mo is ManagementObject
        for mo in moc:
            bit = mo["AddressWidth"]
            if bit == 64:
                prfiles += " (x86)"
        # Value Set
        if sset.default_path == "":
            self.entrys[0].Text = prfiles + "\\Opera\\locale\\ja\\search.ini"
        else:
            self.entrys[0].Text = sset.default_path
        if sset.custome_path == "":
            self.entrys[1].Text = appdata + "\\Opera\\Opera\\search.ini"
        else:
            self.entrys[1].Text = sset.custome_path
        if sset.lang_path == "":
            self.entrys[2].Text = prfiles + "\\Opera\\locale\\ja\\ja.lng"
        else:
            self.entrys[2].Text = sset.lang_path
        # self
        self.Title = "Seeme へようこそ"
        self.SizeToContent = SizeToContent.WidthAndHeight
        self.WindowStartupLocation = WindowStartupLocation.CenterScreen
        self.WindowStyle = WindowStyle.ThreeDBorderWindow

    def on_drag_over(self, sender, e):
        e.Handled = e.Data.GetData(DataFormats.FileDrop) != None

    def on_drop(self, sender, e):
        files = e.Data.GetData(DataFormats.FileDrop)
        sender.Text = str(files[0])

    def on_ok(self, sender, e):
        self.DialogResult = True
        self.Close()

    def on_cancel(self, sender, e):
        self.DialogResult = False
        self.Close()

########################################################################
#
#                               main
#
########################################################################

def main():
    inipath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\sasakima\\seeme\\setting4.ini";
    sset = SeeMeSetting()
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        #sset.prefs_path = ini.read_str("Path", "Prefs1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        MessageBox.Show("%s" % s, MESSAGEDLG_TITLE)
        sys.exit()
    if sset.version < 4:
        # New
        if sset.version == 0:
            description = WELCOME_DESCRIPTION
        else:
            description = CHANGE_DESCRIPTION
        # file version 1 to 2
        sset.default_path = ""
        sset.lang_path    = ""
        # end
        dlg = WelcomeDlg(sset, description)
        try:
            # dlg.Show() で表示すると即終了
            if dlg.ShowDialog():#.Value: は不要
                sset.default_path = dlg.entrys[0].Text
                sset.custome_path = dlg.entrys[1].Text
                sset.lang_path =    dlg.entrys[2].Text
            else:
                MessageBox.Show("bye !", MESSAGEDLG_TITLE)
                return # sys.exit() ではインスタンス終了しない
        except Exception, s:
            MessageBox.Show("%s" % s, MESSAGEDLG_TITLE)
    a = Application()
    a.Run(SeeMe(sset))

if __name__ == "__main__":
    main()